'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = Button;

require('./button.scss');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Button
 * @param   {Object} props     - React props
 * @returns    {JSX} template  - Component template
 */
function Button(props) {
  var active = props.active,
      block = props.block,
      caption = props.caption,
      children = props.children,
      className = props.className,
      disabled = props.disabled,
      display = props.display,
      id = props.id,
      onBlur = props.onBlur,
      onClick = props.onClick,
      onFocus = props.onFocus,
      onKeyUp = props.onKeyUp,
      size = props.size,
      tabIndex = props.tabIndex,
      type = props.type;


  var cssClasses = (0, _classnames2.default)('button', display, size, className, { block: block, active: active }),
      attributes = { disabled: disabled, id: id, onBlur: onBlur, onClick: onClick, onFocus: onFocus, onKeyUp: onKeyUp, tabIndex: tabIndex, type: type };

  return _react2.default.createElement(
    'button',
    _extends({ className: cssClasses }, attributes),
    caption || children
  );
}

Button.propTypes = {
  active: _propTypes2.default.bool,
  block: _propTypes2.default.bool,
  caption: _propTypes2.default.string,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  display: _propTypes2.default.oneOf(['primary', 'link']),
  id: _propTypes2.default.string,
  onBlur: _propTypes2.default.func,
  onClick: _propTypes2.default.func,
  onFocus: _propTypes2.default.func,
  onKeyUp: _propTypes2.default.func,
  size: _propTypes2.default.oneOf(['large', 'small']),
  tabIndex: _propTypes2.default.string,
  type: _propTypes2.default.oneOf(['button', 'submit', 'reset'])
};