'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint-disable react/no-set-state, react/no-did-mount-set-state */


var transitionTime = 400;

/**
 * Collapsible
 */

var Collapsible = function (_Component) {
  _inherits(Collapsible, _Component);

  /**
   * constructor
   * @param {Object} props - React props
   */
  function Collapsible(props) {
    _classCallCheck(this, Collapsible);

    var _this = _possibleConstructorReturn(this, (Collapsible.__proto__ || Object.getPrototypeOf(Collapsible)).call(this, props));

    _this.state = { style: {} };
    return _this;
  }

  /**
   * Right when mounted measure the content's height
   */


  _createClass(Collapsible, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.height = this.getHeight();
      this.setState({
        style: {
          height: this.props.collapsed ? 0 : this.height,
          overflow: this.props.collapsed ? 'hidden' : 'visible'
        }
      });
    }

    /**
     * When collapsing changes reset the content's height
     * @param {object} nextProps - Next props
     */

  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.collapsed !== this.props.collapsed && !this.updating) {
        this.toggleCollapse(nextProps.collapsed);
      }
    }

    /**
     * If content changes reset the content's height
     */

  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      if (this.height !== this.getHeight() && !this.updating) {
        this.height = this.getHeight();
        this.toggleCollapse(this.props.collapsed);
      }
    }

    /**
     * Collapse or uncollapse
     * changing height and overflow
     * @param {boolean} collapsed - True if it's collapsed
     */

  }, {
    key: 'toggleCollapse',
    value: function toggleCollapse(collapsed) {
      var _this2 = this;

      this.updating = true;
      this.setState({
        style: {
          height: collapsed ? 0 : this.height,
          transition: 'height ' + transitionTime / 1000 + 's ease-out',
          overflow: 'hidden'
        }
      });

      setTimeout(function () {
        _this2.setState({
          style: {
            height: collapsed ? 0 : _this2.getHeight(),
            overflow: collapsed ? 'hidden' : 'visible'
          }
        });
        _this2.updating = false;
      }, transitionTime);
    }

    // istanbul ignore next
    /**
     * Measure content's height
     * @returns {string} - Height in pixels
     */

  }, {
    key: 'getHeight',
    value: function getHeight() {
      return this._content.getBoundingClientRect().height;
    }

    /**
     * Render method
     * @returns {JSX} - Component template
     */

  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var children = this.props.children,
          style = this.state.style,
          child = (0, _react.cloneElement)(children, _extends({}, children.props, {
        ref: function ref(content) {
          _this3._content = content;
        }
      }));


      return _react2.default.createElement(
        'div',
        { className: 'collapsible', style: style },
        child
      );
    }
  }]);

  return Collapsible;
}(_react.Component);

exports.default = Collapsible;


Collapsible.propTypes = {
  children: _propTypes2.default.element,
  collapsed: _propTypes2.default.bool
};